SystemOrganization addCategory: #'SUML-Tools'!

DraggingEventHandler subclass: #DiagramNodeEventHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

DiagramNodeEventHandler subclass: #ClassDiagramNodeEventHandler
	instanceVariableNames: ''
	classVariableNames: 'RelationshipBuilder'
	poolDictionaries: ''
	category: 'SUML-Tools'!

!ClassDiagramNodeEventHandler class methodsFor: 'accessing' stamp: 'carlaGriggio 1/2/2011 07:03'!
relationshipBuilder
	RelationshipBuilder ifNil:[ self resetRelationshipBuilder ].
	^RelationshipBuilder 
	! !

!ClassDiagramNodeEventHandler class methodsFor: 'accessing' stamp: 'carlaGriggio 1/2/2011 06:22'!
resetRelationshipBuilder
	RelationshipBuilder := RelationshipGraphicBuilder new
	! !

!ClassDiagramNodeEventHandler methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 06:21'!
doubleClick: evt
	self relationshipBuilder addToRelationship: self passenger from: self event: evt.
	
! !

!ClassDiagramNodeEventHandler methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 06:21'!
mouseDown: evt
	evt yellowButtonPressed
		ifTrue: [ self showActionsMenu ]
		ifFalse: [ super mouseDown: evt. ].
	evt hand
		waitForClicksOrDrag: self passenger
		event: evt
		selectors: {nil. #doubleClick: . nil . nil}
		threshold: 10! !

!ClassDiagramNodeEventHandler methodsFor: 'accessing' stamp: 'carlaGriggio 1/2/2011 06:21'!
relationshipBuilder
	^self class relationshipBuilder ! !

!ClassDiagramNodeEventHandler methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 06:21'!
resetRelationshipBuilder
	self class resetRelationshipBuilder.! !

!ClassDiagramNodeEventHandler methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 06:21'!
showActionsMenu
	| menu |
	menu := MenuMorph new.
	menu addTitle: self passenger diagramNode name.
	menu addStayUpItem.
	menu target: (DiagramNodeManager for: self passenger).
	menu add: 'Delete' action: #delete.
	menu add: 'Rename' action: #rename.
	Smalltalk at: self passenger diagramNode name asSymbol 
		ifPresent:[:class | menu add: 'Browse' action: #browse.].

	menu popUpInWorld.! !

!DiagramNodeEventHandler methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 00:43'!
handleMove: evt
	super handleMove: evt.
	self passenger justDroppedInto: passenger owner event: evt.
	self passenger updateConnections! !

!DiagramNodeEventHandler methodsFor: 'events-accessing' stamp: 'carlaGriggio 1/2/2011 06:30'!
handlesMouseOver: aMouseMoveEvent 
	^false! !

!DiagramNodeEventHandler methodsFor: 'events-accessing' stamp: 'carlaGriggio 1/2/2011 00:46'!
handlesMouseOverDragging: aMouseMoveEvent 
	^false! !

!DiagramNodeEventHandler methodsFor: 'events-accessing' stamp: 'carlaGriggio 1/2/2011 00:28'!
handlesMouseStillDown: aMouseButtonEvent 
	^false! !

!ObjectDiagram methodsFor: '*SUML-Tools' stamp: 'carlaGriggio 8/20/2010 02:49'!
diagramListModelClass 
	^ObjectDiagramModel ! !

DiagramWhiteboard subclass: #SUMLDiagramWhiteboard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!SUMLDiagramWhiteboard methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/16/2010 13:15'!
categoryDiagramsModel
	^self model! !

!SUMLDiagramWhiteboard methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 01:09'!
diagram
	^self categoryDiagramsModel selectedDiagram! !

!SUMLDiagramWhiteboard methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 01:42'!
handlesMouseDown: evt
	^true! !

!SUMLDiagramWhiteboard methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 03:20'!
model: anObject
	model := anObject.
	model ifNotNil: [
		self diagram removeDependent: self.
		model removeDependent: self].
	anObject ifNotNil: [
		.anObject addDependent: self.
		self diagram addDependent: self. ].
	diagramNodes := Dictionary new.! !

!SUMLDiagramWhiteboard methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 01:32'!
mouseDown: evt
	evt yellowButtonPressed ifTrue:[self showActionsMenu ]
	! !

!SUMLDiagramWhiteboard methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 02:04'!
showActionsMenu
	| menu |
	menu := MenuMorph new.
	menu addTitle: self diagram name.
	menu addStayUpItem.
	menu target: (DiagramManager for: self diagram).
	menu add: 'New Class Box' action: #createClassBox.
	menu add: 'New Interface / Type Box' action: #createInterfaceBox.
	menu add: 'New Trait Box' action: #createTraitBox.
	menu add: 'Import Class' action: #createClassBoxFromClass.
	menu add: 'Import Class from ', self diagram category action: #createClassBoxFromCategory.
	menu add: 'Import Trait' action: #createTraitBoxFromTrait.
	menu add: 'Import Trait from ', self diagram category action: #createTraitBoxFromCategory.

	menu addLine.
	menu addLine.  "extra lines ignored"
	menu add: 'peaches' action: #peaches.
	menu addLine.
	menu add: 'pears' action: #pears.
	menu addLine.
	menu popUpInWorld.! !

!SUMLDiagramWhiteboard methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 03:21'!
update: aParameter
	super update: aParameter.
	(aParameter == #diagram) ifTrue:[
		self diagram addDependent: self. ].! !

!Diagram methodsFor: '*SUML-Tools' stamp: 'carlaGriggio 8/20/2010 02:28'!
diagramListModelClass 
	self subclassResponsibility ! !

!Diagram methodsFor: '*SUML-Tools' stamp: 'carlaGriggio 8/20/2010 03:44'!
modelForDiagramsHolder: aDiagramsHolder
	^(self diagramListModelClass new model: self  ) ! !

SHWorkspace subclass: #DiagramWorkspace
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!DiagramWorkspace methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 03:37'!
acceptContents: aText from: anEditor
	self model clearRelationshipsOfSelectedDiagramNode.
	anEditor selectAll;  doIt.
	self model acceptContents: aText .
	self acceptContents: aText.! !

!DiagramWorkspace methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2010 23:52'!
bindingOf: aString
	^self model bindingOf: aString! !

!DiagramWorkspace methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 01:25'!
descriptionCode
	^self model selectedDescriptionCode ! !

!DiagramWorkspace methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/4/2010 02:49'!
doItReceiver 
	^model model! !

!DiagramWorkspace methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/3/2010 17:12'!
hasBindingOf: aString
	^self model hasBindingOf: aString! !

!DiagramWorkspace methodsFor: 'accessing' stamp: 'carlaGriggio 8/3/2010 17:10'!
model
	^ model! !

!DiagramWorkspace methodsFor: 'accessing' stamp: 'carlaGriggio 10/19/2010 22:12'!
model: anObject
	model ifNotNil: [model removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	model := anObject.
	model initializeBindings.! !

!DiagramWorkspace methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/12/2010 14:14'!
update: aParameter
	(aParameter = #descriptionCode)
		ifTrue:[self acceptContents: model selectedDescriptionCode].
	self changed: aParameter! !

Object subclass: #ActionsManager
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!ActionsManager class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 05:45'!
for: aModel
	^self new model: aModel ! !

!ActionsManager methodsFor: 'accessing' stamp: 'carlaGriggio 1/2/2011 05:45'!
model
	^ model! !

!ActionsManager methodsFor: 'accessing' stamp: 'carlaGriggio 1/2/2011 05:45'!
model: anObject
	model := anObject! !

!ActionsManager methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 05:46'!
request: aTitle default: aDefaultValue
	^UIManager default
		request: aTitle
		initialAnswer: aDefaultValue! !

ActionsManager subclass: #DiagramManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!DiagramManager methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 02:00'!
category
	^self diagram category! !

!DiagramManager methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 02:00'!
chooseClassFromCategory
	| dialog choice |
	dialog := PopupChoiceOrRequestDialogWindow new filterInput: false;
		title: 'Choose a class from the category ', self category;
		labels: (SystemOrganization classesInCategory: self category);
		lines: #();
		model: (SystemOrganization classesInCategory: self category).
	choice := (SystemWindow topWindow openModal: dialog) choice.
	dialog cancelled ifTrue: [ ^nil ].
	choice 
		ifNotNil: [ ^choice ]
		ifNil: [ ^dialog filterValue ]! !

!DiagramManager methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 02:01'!
chooseTraitFromCategory
	| dialog choice |
	dialog := PopupChoiceOrRequestDialogWindow new filterInput: false;
		title: 'Choose a trait from the category ', self category;
		labels: (SystemOrganization orderedTraitsIn: self category);
		lines: #();
		model: (SystemOrganization orderedTraitsIn: self category).
	choice := (SystemWindow topWindow openModal: dialog) choice.
	dialog cancelled ifTrue: [ ^nil ].
	choice 
		ifNotNil: [ ^choice ]
		ifNil: [ ^dialog filterValue ]! !

!DiagramManager methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 01:40'!
createClassBox
	| className |
	className := self request: 'Class Name' default: ''.
	self diagram addNewClassDescriptionNamed: className.! !

!DiagramManager methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 02:01'!
createClassBoxFromCategory
	self createClassBoxFromClass: self chooseClassFromCategory.! !

!DiagramManager methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 01:58'!
createClassBoxFromClass
	|className|
	className := self request: 'For which class would you like to create a new Class Box?' default: nil.
	self createClassBoxFromClass: (Smalltalk at: className asSymbol ifAbsent:[nil]).! !

!DiagramManager methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 02:03'!
createClassBoxFromClass: aClass
	aClass ifNotNil: [ self diagram addDiagramNode: (ClassBox fromClass: aClass )].! !

!DiagramManager methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 01:48'!
createInterfaceBox
	| interfaceName |
	interfaceName := self request: 'Interface / Type Name' default: ''.
	self diagram addDiagramNode: (InterfaceBox newNamed: interfaceName).! !

!DiagramManager methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 01:49'!
createTraitBox
	| traitName |
	traitName := self request: 'Trait Name' default: ''.
	self diagram addDiagramNode: (TraitBox newNamed: traitName).! !

!DiagramManager methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 02:01'!
createTraitBoxFromCategory
	self createTraitBoxFromTrait: self chooseTraitFromCategory.! !

!DiagramManager methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 01:56'!
createTraitBoxFromTrait
	|traitName|
	traitName := self request: 'For which trait would you like to create a new Trait Box?' default: nil.
	self createTraitBoxFromTrait: (Smalltalk at: traitName asSymbol ifAbsent:[nil]).! !

!DiagramManager methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 01:56'!
createTraitBoxFromTrait: aTrait
	aTrait ifNotNil:[ self diagram addDiagramNode: (TraitBox  fromTrait: aTrait )]! !

!DiagramManager methodsFor: 'accessing' stamp: 'carlaGriggio 1/2/2011 05:47'!
diagram
	^ self model! !

ActionsManager subclass: #DiagramNodeManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!DiagramNodeManager methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 01:29'!
browse
	|aClass|
	aClass := Smalltalk at: self diagramNode name asSymbol.
	ToolSet browse: aClass selector: nil! !

!DiagramNodeManager methodsFor: 'actions' stamp: 'carlaGriggio 1/2/2011 05:47'!
delete
	self diagram removeDiagramNode: self diagramNode .! !

!DiagramNodeManager methodsFor: 'accessing' stamp: 'carlaGriggio 1/2/2011 05:53'!
diagram
	^self model owner diagram! !

!DiagramNodeManager methodsFor: 'accessing' stamp: 'carlaGriggio 1/2/2011 05:46'!
diagramNode
	^ model diagramNode! !

!DiagramNodeManager methodsFor: 'actions' stamp: 'carlaGriggio 1/2/2011 05:46'!
rename
	| newBoxName newVariableName binding |
	newBoxName := self request: ('New name for ', self diagramNode name) default: ''.
	"binding := self bindingOf: self diagramNode variableNameForDescriptionCode."
	self diagramNode name: newBoxName.
	"binding key: self diagramNode variableNameForDescriptionCode. "
	self diagramNode changed: #title.
	self model changed: #descriptionCode.
	self diagram update: #view.! !

ActionsManager subclass: #RelationshipManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!RelationshipManager methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 05:51'!
delete
	self model removeFromDiagram.! !

!RelationshipManager methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 06:52'!
relationship
	^self model! !

!RelationshipManager methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 06:53'!
rename
	| newLabel  |
	newLabel := self request: ('New label for ', self relationship label) default: ''.
	self relationship label: newLabel.
	self relationship originDiagramNode changed: #view.
	! !

Object subclass: #NullDiagram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!NullDiagram methodsFor: 'accessing' stamp: 'carlaGriggio 8/5/2010 02:08'!
classBoxes
	^#()! !

!NullDiagram methodsFor: 'accessing' stamp: 'carlaGriggio 8/5/2010 02:12'!
descriptionCodeOf: aClassDescription
	^String empty! !

!NullDiagram methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 02:30'!
diagramNodes
	^#()! !

!NullDiagram methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/12/2010 11:24'!
modelForDiagramsHolder: aDiagramsHolder
	^(DiagramModel new model: self  ) ! !

!NullDiagram methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 17:23'!
name
	^'(No diagrams)'! !

!NullDiagram methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/12/2010 11:29'!
saveDescriptionIn: aClass 
	! !

!NullDiagram methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 17:18'!
update! !

Object subclass: #NullDiagramNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!NullDiagramNode methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 02:48'!
descriptionCodeForEdition
	^String empty ! !

Object subclass: #RelationshipGraphicBuilder
	instanceVariableNames: 'origin destination originIndicatorMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!RelationshipGraphicBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 06:35'!
addToRelationship: aDiagramNodeMorph from: aDiagramNodeEventHandler event: evt
	origin 
		ifNil:[origin := aDiagramNodeMorph.
			originIndicatorMorph :=  (CircleMorph new borderWidth: 0; color: (Color red alpha: 0.5); center: evt position).
			aDiagramNodeMorph owner addMorph: originIndicatorMorph  ]
		ifNotNil: [destination := aDiagramNodeMorph.
				self createRelationship.
				aDiagramNodeEventHandler resetRelationshipBuilder.
				originIndicatorMorph delete.]
	! !

!RelationshipGraphicBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 06:02'!
createRelationship
	self showActionsMenu.
	! !

!RelationshipGraphicBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 04:44'!
initialize 
	 ! !

!RelationshipGraphicBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 06:02'!
newAssociation
	| label |
	label := self request: 'label' default: ''.
	origin diagramNode hasA: destination diagramNode labeledAs: label.! !

!RelationshipGraphicBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 06:06'!
newCollectionAssociation
	| label |
	label := self request: 'label' default: ''.
	origin diagramNode hasLotsOf: destination diagramNode labeledAs: label.! !

!RelationshipGraphicBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 06:11'!
newCollectionUse
	origin diagramNode usesLotsOf: destination diagramNode .
! !

!RelationshipGraphicBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 06:07'!
newImplementation
	origin diagramNode implements: destination diagramNode .
! !

!RelationshipGraphicBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 06:02'!
newInheritance
	origin diagramNode inheritsFrom: destination diagramNode .
! !

!RelationshipGraphicBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 06:11'!
newUse
	origin diagramNode usesA: destination diagramNode .
! !

!RelationshipGraphicBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 06:07'!
newUseTrait
	origin diagramNode usesTrait: destination diagramNode .
! !

!RelationshipGraphicBuilder methodsFor: 'accessing' stamp: 'carlaGriggio 1/2/2011 04:56'!
origin: aDiagramNodeMorph
	origin := aDiagramNodeMorph diagramNode! !

!RelationshipGraphicBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 06:00'!
request: aTitle default: aDefaultValue
	^UIManager default
		request: aTitle
		initialAnswer: aDefaultValue! !

!RelationshipGraphicBuilder methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 06:11'!
showActionsMenu
	| menu |
	menu := MenuMorph new.
	menu addTitle: 'New Relationship'.
	menu addStayUpItem.
	menu target: self.
	menu add: 'Association' action: #newAssociation.
	menu add: 'Association *' action: #newCollectionAssociation.
	menu add: 'Inheritance' action: #newInheritance.
	menu add: 'Implementation' action: #newImplementation.
	menu add: 'Use' action: #newUse.
	menu add: 'Use *' action: #newCollectionUse.
	menu add: 'Use of Trait' action: #newUseTrait.
	
	menu popUpInWorld.! !

Object subclass: #UMLDiagramListModel
	instanceVariableNames: 'diagramModel selectedIndex bindings diagramsHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 10/30/2010 16:30'!
acceptContents: aText 
	"The binding actually has an Updater"
	self bindingOfSelectedDiagramNode update.
	self changed: #list.
	self changed: #descriptionCode.
	self changed: #view.
	self changed.! !

!UMLDiagramListModel methodsFor: 'binding' stamp: 'carlaGriggio 11/11/2010 21:02'!
bindingOf: aString
	^self model bindingOf: aString ! !

!UMLDiagramListModel methodsFor: 'binding' stamp: 'carlaGriggio 8/20/2010 03:38'!
bindingOfSelectedDiagramNode
	^(self bindingOf: self selectedDiagramNode variableNameForDescriptionCode) value! !

!UMLDiagramListModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 00:07'!
category
	^self model category! !

!UMLDiagramListModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2010 21:06'!
changed
	self initializeBindings.
	self changed: #list.
	self changed: #view.
	self changed: #descriptionCode.
	super changed.! !

!UMLDiagramListModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/12/2010 13:56'!
changed: aParameter
	((aParameter = #position) or:[(aParameter = #descriptionCode)]) 
		ifTrue: [
				self selectedDiagram saveDescriptionIn: self diagramsHolder. 
				self changed: #list]. 
	((aParameter ~= #descriptionCode) and:[(aParameter  ~= #list)]) 
		ifTrue:[self model changed: aParameter].
	((aParameter = #selectedIndex) or:[aParameter = #position])
		ifTrue:[
			self changed: #descriptionCode.].
	(aParameter = #view)
		ifTrue:[
			self diagramsHolder changed: #view].
	super changed: aParameter ! !

!UMLDiagramListModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 03:38'!
clearRelationshipsOfSelectedDiagramNode 
	self bindingOfSelectedDiagramNode clearRelationships ! !

!UMLDiagramListModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 00:07'!
diagramName 
	^self selectedDiagram name! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 04:43'!
diagramNodes
	^self selectedDiagram  diagramNodes ! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 03:39'!
diagramsHolder
	^ diagramsHolder! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 04:06'!
diagramsHolder: anObject
	diagramsHolder := anObject! !

!UMLDiagramListModel methodsFor: 'binding' stamp: 'carlaGriggio 11/11/2010 21:03'!
hasBindingOf: aString
	^self model hasBindingOf: aString ! !

!UMLDiagramListModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 00:07'!
initialize 
	selectedIndex := 1.! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 11/11/2010 21:05'!
initializeBindings 
	self model initializeBindings ! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 01:23'!
list
	^self model list! !

!UMLDiagramListModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 05:31'!
listMenu: aMenu shifted: shifted
	aMenu target: self model.
	^self model listMenu: aMenu shifted: shifted! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 01:21'!
model
	^ diagramModel ! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 11/11/2010 21:05'!
model: anObject
	diagramModel  := anObject.
	diagramModel ifNotNil: [diagramModel removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	self initializeBindings.
	selectedIndex := 1.
	self changed: #list
	! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 11/12/2010 14:11'!
selectedDescriptionCode
	^self selectedDiagram descriptionCodeOf: self selectedDiagramNode! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 01:28'!
selectedDiagram
	^self model model! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/24/2010 09:59'!
selectedDiagramNode
	^self model selectedDiagramNode ! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 00:07'!
selectedIndex
	^ selectedIndex! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 01:53'!
selectedIndex: anIndex
	anIndex > 0
		ifTrue: [ 
			selectedIndex := anIndex.
			self changed: #selectedIndex.
			]! !

!UMLDiagramListModel methodsFor: 'accessing' stamp: 'carlaGriggio 11/12/2010 11:49'!
update: aParameter
	(aParameter = #list) ifTrue:[self changed: #list].
	(aParameter = #descriptionCode)
		ifTrue:[self changed: #descriptionCode].

	(aParameter = #view)
		ifTrue:[self diagramsHolder changed: #view].
			
	(aParameter = #selectedIndex )
		ifTrue:[
				
				self model selectedIndex: self selectedIndex. 
				
				self changed: #list. 
				self changed: #descriptionCode].
	super update: aParameter.
	self initializeBindings.! !

!UMLDiagramListModel methodsFor: 'updating' stamp: 'carlaGriggio 9/13/2010 10:40'!
updateView
	self dependents do:[:dep | dep update: #view]! !

Object subclass: #UMLToolModel
	instanceVariableNames: 'model selectedIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

UMLToolModel subclass: #CategoryDiagramsModel
	instanceVariableNames: 'selectedDiagramModel diagrams'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/13/2010 14:51'!
addDiagram: aDiagram
	self model addDiagram: aDiagram.
	diagrams add: aDiagram.! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/12/2010 12:22'!
changed
	self diagramListModel model: self selectedDiagramModel.
	super changed.! !

!CategoryDiagramsModel methodsFor: 'accessing' stamp: 'carlaGriggio 1/2/2011 03:20'!
changed: aParameter
	(aParameter == #selectedIndex)
		ifTrue:[
			self diagramListModel model: self selectedDiagramModel.
"			self diagramListModel changed: #list."
			self diagramListModel changed: #descriptionCode.
			self changed: #view.
			"self changed: #relabel"
			self changed: #diagram].

	super changed: aParameter ! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/13/2010 14:52'!
createDiagram
	|diagramName newDiagram |
	diagramName := self request: 'Diagram Name' default: ''.
	newDiagram:= (ClassDiagram new name: diagramName).
	self addDiagram: newDiagram .
	self changed: #list.
	self selectedIndex: self list size.
	
	! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/12/2010 19:14'!
createInheritanceDiagram
	|className newDiagram |
	className := self request: 'Root Class for the inheritance diagram' default: ''.
	newDiagram := (ClassDiagram inheritanceFor: (Smalltalk at: className asSymbol) ).
	self model addDiagram: newDiagram.
	diagrams add: newDiagram.
	self selectedIndex: self list size.
	self changed: #list.
	! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/12/2010 14:59'!
deleteDiagram
	self model removeDiagram: self selectedDiagram .
	diagrams remove: self selectedDiagram.
	self changed: #list.
	(self list notEmpty and:[ self selectedIndex > 1]) 
		ifTrue: [self selectedIndex: self selectedIndex -1].
	(self list notEmpty and:[ self selectedIndex = 1]) 
		ifTrue:[self selectedIndex: 1].
	self changed: #selectedIndex.
	

! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 04:06'!
diagramListModel
	^selectedDiagramModel ifNil:[selectedDiagramModel := UMLDiagramListModel new diagramsHolder: self model; model: (self selectedDiagramModel)]! !

!CategoryDiagramsModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/19/2010 20:29'!
diagramNodes
	^self selectedDiagram diagramNodes ! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/10/2010 02:20'!
exportDiagramAsWorkspace
	Workspace new saveString: self selectedDiagram descriptionCode toFile: self selectedDiagram name, '.ws' ! !

!CategoryDiagramsModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/6/2010 16:52'!
labelString
	^self model category, ' - ', self selectedDiagram name! !

!CategoryDiagramsModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/19/2010 21:10'!
list
	^diagrams ifNil:[ diagrams:= self model diagrams]! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/30/2010 04:43'!
listMenu: aMenu shifted: aBoolean
	self list ifNotEmpty: [
		aMenu addList: #(
		('delete diagram'	deleteDiagram)
		('rename diagram'	renameDiagram)
		)].
	aMenu addLine.
	aMenu addList: #(('add diagram'	createDiagram)).
	aMenu addList: #(('add inheritance diagram' createInheritanceDiagram)).
	aMenu addLine.
	aMenu addList: #(
		('save diagram as PNG' saveDiagramAsPNG)
		('export diagram description code as a workspace'  exportDiagramAsWorkspace)).
	^ aMenu! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/13/2010 14:51'!
renameDiagram
	|diagramName currentDiagram|
	diagramName := self request: 'New name for ', self selectedDiagram name default: nil.
	diagramName ifNotNil: [currentDiagram := self selectedDiagram.
	self deleteDiagram.
	currentDiagram name: diagramName.
	self addDiagram: currentDiagram.
	self changed: #list.
	self changed: #selectedIndex.
	self changed.]
	! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/16/2010 13:35'!
saveDiagramAsPNG
	PNGReadWriter putForm: ((SUMLDiagramWhiteboard new model: self diagramListModel) update) imageForm onFileNamed: self selectedDiagram name, '.png'.
! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/5/2010 02:07'!
selectedDiagram
	^ self list at: self selectedIndex ifAbsent:[NullDiagram new]! !

!CategoryDiagramsModel methodsFor: 'accessing' stamp: 'carlaGriggio 11/12/2010 11:33'!
selectedDiagramModel
	^self selectedDiagram modelForDiagramsHolder: self model! !

!CategoryDiagramsModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/12/2010 13:59'!
update: aParameter
	
	(aParameter = #view) ifTrue:[self changed: #view].
	(aParameter = #descriptionCode) ifTrue:[self changed: #list].
	self diagramListModel changed: #descriptionCode.
	super update: aParameter.! !

UMLToolModel subclass: #DiagramModel
	instanceVariableNames: 'bindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

DiagramModel subclass: #ClassDiagramModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!ClassDiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 01:01'!
bindingErrorBecauseOf: aVariable
	^'No class description associated with the variable: ', aVariable ! !

!ClassDiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/12/2010 12:31'!
changed
	super changed.
	self changed: #descriptionCode.
	self changed: #view.! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/20/2010 13:36'!
chooseClassFromCategory
	| dialog choice |
	dialog := PopupChoiceOrRequestDialogWindow new filterInput: false;
		title: 'Choose a class from the category ', self category;
		labels: (SystemOrganization classesInCategory: self category);
		lines: #();
		model: (SystemOrganization classesInCategory: self category).
	choice := (SystemWindow topWindow openModal: dialog) choice.
	dialog cancelled ifTrue: [ ^nil ].
	choice 
		ifNotNil: [ ^"self checkBoxName: "choice ]
		ifNil: [ ^dialog filterValue ]! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/19/2010 09:08'!
chooseTraitFromCategory
	| dialog choice |
	dialog := PopupChoiceOrRequestDialogWindow new filterInput: false;
		title: 'Choose a trait from the category ', self category;
		labels: (SystemOrganization orderedTraitsIn: self category);
		lines: #();
		model: (SystemOrganization orderedTraitsIn: self category).
	choice := (SystemWindow topWindow openModal: dialog) choice.
	dialog cancelled ifTrue: [ ^nil ].
	choice 
		ifNotNil: [ ^self checkBoxName: choice ]
		ifNil: [ ^dialog filterValue ]! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 11/12/2010 11:55'!
createClassBox
	| className |
	className := self request: 'Class Name' default: ''.
	self checkBoxName: className.
	self model addNewClassDescriptionNamed: className.
	self changed.! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/19/2010 09:08'!
createClassBoxFromCategory
	self createClassBoxFromClass: self chooseClassFromCategory.
	self changed.! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/19/2010 09:08'!
createClassBoxFromClass
	|className|
	className := self request: 'For which class would you like to create a new Class Box?' default: nil.
	self checkBoxName: className.
	className ifNotNil:[self createClassBoxFromClass: (Smalltalk at: className asSymbol ).
	self changed.]! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 11/11/2010 21:08'!
createClassBoxFromClass: aClass
	aClass ifNotNil: [ self model addDiagramNode: (ClassBox fromClass: aClass )].
	self changed.! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 11/12/2010 20:48'!
createInterfaceBox
	| interfaceName |
	interfaceName := self request: 'Interface / Type Name' default: ''.
	self checkBoxName: interfaceName .
	self model addDiagramNode: (InterfaceBox newNamed: interfaceName).
	self changed.! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/20/2010 02:29'!
createTraitBox
	| traitName |
	traitName := self request: 'Trait Name' default: ''.
	self checkBoxName: traitName .
	self model addDiagramNode: (TraitBox new boxTitle: traitName).
	self changed.! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/19/2010 09:09'!
createTraitBoxFromCategory
	self createTraitBoxFromTrait: self chooseTraitFromCategory.
	self changed.! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/19/2010 09:09'!
createTraitBoxFromTrait
	|traitName|
	traitName := self request: 'For which trait would you like to create a new Trait Box?' default: nil.
	self checkBoxName: traitName .
	self createTraitBoxFromTrait: (Smalltalk at: traitName asSymbol ).
	self changed.! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/20/2010 02:29'!
createTraitBoxFromTrait: aTrait
	aTrait ifNotNil:[ self model addDiagramNode: (TraitBox  fromTrait: aTrait )]! !

!ClassDiagramModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 01:10'!
descriptionCode
	^self model descriptionCodeOf: self selectedDiagramNode ! !

!ClassDiagramModel methodsFor: 'accessing' stamp: 'carlaGriggio 11/12/2010 11:42'!
list
	^self model ifNotNil:[self model diagramNodes]
	ifNil:[#()]! !

!ClassDiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 1/2/2011 00:38'!
listMenu: aMenu shifted: shifted
	self list ifNotEmpty:[
		aMenu addList: #(('Delete box'	#deleteNode) ('Rename box'	#renameNode));
			addLine].
		aMenu 
			addList: #(
					('Add new class box' 		#createClassBox) 
					('Add new class box from existing class in category' #createClassBoxFromCategory)
					('Add new class box from existing class' #createClassBoxFromClass)
					('Add new interface / type box' 		#createInterfaceBox)
					('Add new trait box' 		#createTraitBox)
					('Add new trait box from existing trait in category' #createTraitBoxFromCategory)
					('Add new trait box from existing trait' #createTraitBoxFromTrait)
					 ).

	^ aMenu ! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 01:01'!
bindingErrorBecauseOf: aVariable
	self subclassResponsibility ! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2010 21:23'!
bindingOf: aString
	^bindings associationAt: aString ifAbsent:[self error: (self model bindingErrorBecauseOf: aString ) ].! !

!DiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 11/11/2010 21:20'!
checkBoxName: aBoxName
	(bindings values anySatisfy: [:box | box name = aBoxName ]) ifTrue:[self error: 'There already exists a diagram node named ', aBoxName ].
	^aBoxName ! !

!DiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 11/12/2010 20:36'!
deleteNode
	self model removeDiagramNode: self selectedDiagramNode .
	self selectedIndex: self selectedIndex -1.
	self changed: #descriptionCode.
	self changed: #selectedIndex.
	self changed: #view.
	
! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2010 23:54'!
hasBindingOf: aString
	^(bindings notNil and: [bindings includesKey: aString])! !

!DiagramModel methodsFor: 'binding' stamp: 'carlaGriggio 11/11/2010 21:01'!
initializeBindings
	bindings := Dictionary new.
	self list do:[:de |
		bindings at: de variableNameForDescriptionCode put:  (de updaterClass new realDiagramNode: de)]! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/19/2010 22:15'!
list
	^self model ifNotNil:[self model diagramNodes]
	 "This should be changed when integrating other kinds of diagrams, doing a double dispatch maybe"
	ifNil:[#()]! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/12/2010 20:46'!
model: aModel
	super model: aModel.
	model ifNotNil: [model removeDependent: self].
	aModel ifNotNil: [aModel addDependent: self].
! !

!DiagramModel methodsFor: 'menu-options' stamp: 'carlaGriggio 8/20/2010 05:27'!
renameNode
	| newBoxName newVariableName binding |
	newBoxName := self request: ('New name for ', self selectedDiagramNode name) default: ''.
	binding := self bindingOf: self selectedDiagramNode variableNameForDescriptionCode.
	self selectedDiagramNode name: newBoxName.
	binding key: self selectedDiagramNode variableNameForDescriptionCode. 
	self changed.! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 01:25'!
selectedDescriptionCode
	^self model descriptionCodeOf: self selectedDiagramNode! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 9/13/2010 10:17'!
selectedDiagramNode
	^self list at: self selectedIndex ifAbsent:[NullDiagramNode new]! !

!DiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 9/2/2010 10:50'!
selectedIndex: anIndex
	anIndex > 0
		ifTrue: [ 
			selectedIndex := anIndex.
			]! !

DiagramModel subclass: #ObjectDiagramModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!ObjectDiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 01:01'!
bindingErrorBecauseOf: aVariable
	^'No object node associated with the variable: ', aVariable ! !

!ObjectDiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 05:33'!
createNode
	| name |
	name := self request: 'Object Name' default: ''.
	"self checkBoxName: name."
	self model addDiagramNode: (ObjectNode named: name).
	self changed.! !

!ObjectDiagramModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 05:31'!
listMenu: aMenu shifted: shifted
	self list ifNotEmpty:[
		aMenu addList: #(('Delete object'	#deleteNode) ('Rename object'	renameNode));
			addLine].
		aMenu 
			addList: #(
					('Add new object node' 		#createNode) 
					 ).

	^ aMenu ! !

!UMLToolModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 15:41'!
category
	^self model category! !

!UMLToolModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/3/2010 00:46'!
diagramName 
	^self selectedDiagram name! !

!UMLToolModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/3/2010 01:34'!
initialize 
	selectedIndex := 1.! !

!UMLToolModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/3/2010 00:46'!
list
	self subclassResponsibility! !

!UMLToolModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/3/2010 00:46'!
model
	^ model! !

!UMLToolModel methodsFor: 'accessing' stamp: 'carlaGriggio 11/12/2010 20:45'!
model: anObject
	model := anObject.
! !

!UMLToolModel methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/5/2010 03:11'!
request: aTitle default: aDefaultValue
	^UIManager default
		request: aTitle
		initialAnswer: aDefaultValue! !

!UMLToolModel methodsFor: 'accessing' stamp: 'carlaGriggio 8/3/2010 00:46'!
selectedIndex
	^ selectedIndex! !

!UMLToolModel methodsFor: 'accessing' stamp: 'carlaGriggio 9/2/2010 10:50'!
selectedIndex: anIndex
	anIndex > 0
		ifTrue: [ 
			selectedIndex := anIndex.
			self changed: #selectedIndex.
			]! !

!UMLToolModel methodsFor: 'accessing' stamp: 'carlaGriggio 11/11/2010 02:42'!
update: anObject 
	super update: anObject.
	(anObject ~= #descriptionCode) ifTrue: [self changed: #list.]! !

!ClassDiagram methodsFor: '*SUML-Tools' stamp: 'carlaGriggio 8/20/2010 02:28'!
diagramListModelClass 
	^ClassDiagramModel! !

PluggableShoutMorph subclass: #PluggableShoutEditorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!PluggableShoutEditorMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 03:03'!
selectAll
	super selectAll.
	selectionInterval := self textMorph editor selectionInterval.! !

!PluggableShoutEditorMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 03:01'!
selectFrom: start to: stop
	super selectFrom: start to: stop.
	selectionInterval := self textMorph editor selectionInterval.! !

SystemWindow subclass: #UMLDiagramWindow
	instanceVariableNames: 'diagram'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-Tools'!

!UMLDiagramWindow class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/1/2010 16:42'!
on: aModel
	^(self new model: aModel) createView ! !

!UMLDiagramWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/31/2010 19:53'!
acceptContents: contents 
	self model: (Compiler evaluate: contents)! !

!UMLDiagramWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/2/2011 02:32'!
createView 
	| diagramCode scrollPane|
	diagramCode  := (PluggableShoutEditorMorph 
		on: (DiagramWorkspace new model: model diagramListModel) 
		text: #descriptionCode 
		accept: #acceptContents:from:
		readSelection: nil 
		menu: #codePaneMenu:shifted:).
scrollPane := ScrollPane new.
diagram := SUMLDiagramWhiteboard new . 
diagram extent: 1000@2000.
diagram clipSubmorphs: false.
diagram model: model.
diagram update.
scrollPane scroller addMorph: diagram.
diagram position: 0@0.

self addMorph: scrollPane frame: (0@0 corner: 1@0.8).
self addMorph: (self diagramsList addDependent: diagram; yourself)frame: (0@0.8 corner: 0.25@1).
self addMorph: self descriptionsList frame: (0.25@0.8 corner: 0.5@1).
self addMorph: diagramCode frame: (0.5@0.8 corner: 1@1).
! !

!UMLDiagramWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/31/2010 19:57'!
descriptionCode 
	^model ifNil: [''] ifNotNil: [model descriptionCode] ! !

!UMLDiagramWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/20/2010 02:00'!
descriptionsList
	^PluggableListMorph new
		on: self model diagramListModel
		list: #list
		selected: #selectedIndex
		changeSelected: #selectedIndex:
		menu: #listMenu:shifted:
		keystroke: #listKey:from:;
		 borderWidth: 0;
		 enableDragNDrop: false;
		 autoDeselect: true;
		 yourself! !

!UMLDiagramWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/1/2010 23:44'!
diagramsList
	^PluggableListMorph new
		on: self model
		list: #list
		selected: #selectedIndex
		changeSelected: #selectedIndex:
		menu: #listMenu:shifted:
		keystroke: #listKey:from:;
		 borderWidth: 0;
		 enableDragNDrop: false;
		 autoDeselect: true;
		 yourself! !

!UMLDiagramWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/1/2010 16:46'!
model: aModel
	super model: aModel.
	self setLabel: model diagramName.

! !

!UMLDiagramWindow methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 02:00'!
selectedDescriptionModel
	^self model diagramListModel ! !
